﻿using HarmonyLib;
using System.Reflection;
using UnityEngine;

public class CrouchToggle : Mod
{
    Harmony instance;

    private void Start()
    {
        instance = new Harmony("com.github.alexpw.crouchtoggle");
        instance.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("CrouchToggle mod loaded!");
    }

    public void OnModUnload()
    {
        instance.UnpatchAll("com.github.alexpw.crouchtoggle");
    }
}

[HarmonyPatch(typeof(PersonController))]
[HarmonyPatch("GroundControll")]
internal class PersonController_GroundControll_Patch
{
    private static void Postfix(PersonController __instance, ref Network_Player ___playerNetwork, ref Vector3 ___moveDirection)
    {
        bool crouching = __instance.crouching;
        if (MyInput.GetButtonUp("Crouch"))
        {
            isCrouching = !isCrouching;
        }
        __instance.crouching = isCrouching;
        ___playerNetwork.Animator.anim.SetBool("Crouching", isCrouching);
        if (crouching && !isCrouching)
        {
            ___moveDirection /= __instance.normalSpeed * Stat_WellBeing.groundSpeedMultiplier;
        }
    }

    private static bool isCrouching;
}